#include "mqtt.h"

#include <string>
#include "polyfill.h"

#include "esp_log.h"
#include <driver/adc.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"

#define SLEEP_PERIOD 60 * 1000 / portTICK_PERIOD_MS

bool message = false;
void soil_moisture_sensor_task(void* arg) {
    adc1_config_width(ADC_WIDTH_12Bit);
    adc1_config_channel_atten(ADC1_CHANNEL_4, ADC_ATTEN_DB_11);

    while (true) {
        int value = 0;
        for (int i = 0; i < 16; i++) {
            value += adc1_get_raw(ADC1_CHANNEL_4);
            vTaskDelay(1000 / 16 / portTICK_PERIOD_MS);
        }
        publish_message("device/plant_auto/soil_moisture", to_string(value));
        ESP_LOGI("SOIL_SENSOR", "%i", value);

        if (!message && value < 30000) {
            publish_message("edi/cmd/say", "{\"args\": \"iiiiih, ich bin nass\"}");
            message = true;
        }

        vTaskDelay(1 * 1000 / portTICK_PERIOD_MS);
    }
}

void add_soil_moisture_sensor() {
    xTaskCreate(soil_moisture_sensor_task, "soil_moisture_sensor_task", 2048, NULL, 4, NULL);
}